summaryrefslogtreecommitdiffstats
path: root/source/installer/dropbear/dropbear.Slackbuild
diff options
context:
space:
mode:
Diffstat (limited to 'source/installer/dropbear/dropbear.Slackbuild')
-rwxr-xr-xsource/installer/dropbear/dropbear.Slackbuild131
1 files changed, 131 insertions, 0 deletions
diff --git a/source/installer/dropbear/dropbear.Slackbuild b/source/installer/dropbear/dropbear.Slackbuild
new file mode 100755
index 000000000..5bd3bd99d
--- /dev/null
+++ b/source/installer/dropbear/dropbear.Slackbuild
@@ -0,0 +1,131 @@
+#!/bin/sh
+# $Id: dropbear.Slackbuild,v 1.7 2008/03/13 13:42:33 root Exp root $
+# Copyright 2007, Piter Punk, São Paulo, Brazil
+# Adaptations for Slackware installer:
+# Copyright 2008, Eric Hameleers, Eindhoven, Netherlands
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=dropbear
+VERSION=0.50
+ARCH=${ARCH:-i486}
+BUILD=${BUILD:-10}
+TAG=${TAG:-''}
+
+# The programs we want to have as symlinks to dropbearmulti binary:
+PROGS="dropbear dbclient dropbearkey dropbearconvert scp ssh"
+
+# We build for the Slackware installer:
+# This means, installing into /bin and /sbin ;
+# and adding symlinks for ssh and scp without worry
+# about overwriting any pre-existing binaries.
+
+CWD=`pwd`
+TMP=${TMP:-/tmp}
+PKG=$TMP/pkg-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2"
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP || exit 1
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.bz2 || exit 1
+cd $PRGNAM-$VERSION || exit 1
+
+# Fix ownership and permissions inside the source tarball.
+# It's appalling how many projects have 777 permissions or
+# even suid, sgid, and sticky bits set on things.
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
+
+# Patch to allow empty passwords (used in Slackware's installer):
+patch -p1 < $CWD/dropbear_emptypass.patch
+# Apply xauth path patch
+patch -p0 < $CWD/dropbear.xauth.patch
+# Change the path used for dbclient because our prefix is '/' not '/usr':
+patch -p1 < $CWD/dropbear_dbclientpath.patch
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/ \
+ --mandir=/usr/man \
+ --disable-syslog \
+ --disable-utmp \
+ --disable-utmpx \
+ --disable-wtmp \
+ --disable-wtmpx \
+ --disable-pututline \
+ --disable-pututxline \
+ --build=$ARCH-slackware-linux
+
+make PROGRAMS="$PROGS" MULTI="1" SCPPROGRESS="1" || exit 1
+mkdir -p $PKG/sbin $PKG/bin $PKG/lib
+make DESTDIR=$PKG MULTI="1" install || exit 1
+
+# Copy manpages to package
+mkdir -p $PKG/usr/man/man1
+mkdir -p $PKG/usr/man/man8
+cp dbclient.1 $PKG/usr/man/man1
+cp dropbearkey.8 dropbear.8 $PKG/usr/man/man8
+
+if [ -d $PKG/usr/man ]; then
+ (cd $PKG/usr/man
+ find . -type f -exec gzip -9 {} \;
+ for i in `find . -type l` ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+ )
+fi
+
+# Link binaries to dropbearmulti since the 'make install' does not do that
+# if we build a multicall binary.
+(cd $PKG/bin
+ ln -s ../bin/dropbearmulti ../sbin/dropbear
+ for i in $(echo $PROGS | sed -e 's/dropbear //') ; do
+ ln -s dropbearmulti $i
+ done
+)
+
+(cd $PKG
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+)
+
+mkdir -p $PKG/etc/rc.d $PKG/etc/dropbear
+cp $CWD/rc.dropbear.new $PKG/etc/rc.d/ # doinst.sh will handle .new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a CHANGES INSTALL LICENSE MULTI README SMALL TODO \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.tgz